package com.weltevree.salvo.core;

import static org.junit.Assert.fail;
import static junit.framework.Assert.assertTrue;

import org.junit.AfterClass;
import org.junit.BeforeClass;
import org.junit.Test;

import com.weltevree.salvo.core.internal.Server;
import com.weltevree.salvo.model.IServer;

public class ServerTest {

	final static String SERVER = "news.eclipse.org";
	final static String USER = "exquisitus";
	final static String PASSWORD = "flinder1f7";
	final static String EMAIL = "wim.jongman@gmail.com";
	private static final int PORT = 119;
	private static IServer server;

	@BeforeClass
	public static void setUpBeforeClass() throws Exception {

		server = Server.getServer(SERVER, PORT, USER, EMAIL, USER, PASSWORD, true);
		assertTrue("Could not connect to Server", server.getServerConnection()
				.isConnected());

	}

	@AfterClass
	public static void tearDownAfterClass() throws Exception {

	}

	@Test
	public void testServer() {
		assertTrue("Server is null", server != null);
	}

	@Test
	public void testGetResponse() {
		server.getServerConnection().disconnect();
		server.getServerConnection().connect(PASSWORD);
		server.getServerConnection().sendCommand("mode reader");
		assertTrue(server.getServerConnection().getResponse()
				.startsWith("200 "));
	}

	@Test
	public void testGetLastResponse() {
		assertTrue(server.getServerConnection().getLastResponse().startsWith(
				"200 "));
	}

	@Test
	public void testGetListResponse() {
		server.getServerConnection().sendCommand("list newsgroups");
		assertTrue(server.getServerConnection().getListResponse().length + "",
				server.getServerConnection().getListResponse().length == 141);
	}

	@Test
	public void testGetNewsGroups() {
		server.getServerConnection().getNewsgroups();
		assertTrue(server.getServerConnection().getNewsgroups().size() + "",
				server.getServerConnection().getNewsgroups().size() == 139);
	}

	@Test
	public void testSendCommand() {
		server.getServerConnection().sendCommand("mode reader");
		assertTrue(server.getServerConnection().getResponse()
				.startsWith("200 "));
	}

	@Test
	public void testGetPort() {

		assertTrue(server.getPort() == PORT);
	}

	@Test
	public void testGetAddress() {
		assertTrue(server.getAddress().equals(SERVER));
	}

	@Test
	public void testIsConnected() {
		assertTrue(server.getServerConnection().isConnected());
	}

	@Test
	public void testGetLastException() {
		if (server.getServerConnection().getLastException() != null)
			fail(server.getServerConnection().getLastException().getMessage());
	}

	@Test
	public void testDisconnet() {
		assertTrue(server.getServerConnection().disconnect());
	}

}
