package com.weltevree.salvo.core;

import java.io.File;
import java.io.FileInputStream;
import java.io.ObjectInputStream;

import com.weltevree.salvo.core.internal.Newsgroup;
import com.weltevree.salvo.model.INewsgroup;
import com.weltevree.salvo.model.IServer;

public class NewsgroupFactory {

	public static INewsgroup createNewsGroup(IServer server, String newsgroup,
			String description) {
		return new Newsgroup(server, newsgroup, description);
	}

	public static INewsgroup createNewsGroup(File file) {
		if (file.exists()) {
			try {
				FileInputStream f_in = new FileInputStream(file);
				ObjectInputStream obj_in = new ObjectInputStream(f_in);
				Object obj = obj_in.readObject();
				if (obj instanceof INewsgroup) {
					return (INewsgroup) obj;
				}
			} catch (Exception e) {
			}
		}
		return null;
	}
}
