package com.weltevree.salvo.core;

import com.weltevree.salvo.core.internal.ServerStoreFacade;
import com.weltevree.salvo.model.IServerStoreFacade;

public class ServerStoreFactory {

	private static ServerStoreFactory factory;

	private ServerStoreFacade facade;

	public IServerStoreFacade getServerStoreFacade() {
		
		if (facade == null) {
			facade = new ServerStoreFacade(StoreFactory.instance().getStores());
			facade.init();
		}
		return facade;
	}

	public static ServerStoreFactory instance() {
		if (factory == null)
			factory = new ServerStoreFactory();
		return factory;
	}

}
