package com.weltevree.salvo.core;

import java.util.Collection;
import java.util.HashMap;

import com.weltevree.salvo.model.IStore;

public class StoreFactory {

	private static StoreFactory factory;

	private HashMap<String, IStore> stores = new HashMap<String, IStore>();

	public void addStore(IStore store) {
		stores.put(store.getDescription(), store);
	}

	public Collection<IStore> getStores() {
		return stores.values();
	}

	public static StoreFactory instance() {
		if (factory == null)
			factory = new StoreFactory();
		return factory;
	}

}
