package com.weltevree.salvo.core.internal;

import com.weltevree.salvo.core.Debug;
import com.weltevree.salvo.core.ServerStoreFactory;
import com.weltevree.salvo.model.INewsgroup;
import com.weltevree.salvo.model.IServer;
import com.weltevree.salvo.model.IServerStoreFacade;
import com.weltevree.salvo.model.IStore;

public final class UpdateRunner implements Runnable {
	private boolean threadRunning;

	public void run() {

		setThreadRunning(true);

		IServerStoreFacade facade = ServerStoreFactory.instance()
				.getServerStoreFacade();
		while (facade.getStores() == null) {
			facade = ServerStoreFactory.instance().getServerStoreFacade();
			try {
				Debug.log(getClass(), "Salvo Thread: Waiting for Store");
				Thread.sleep(100);
			} catch (InterruptedException e) {
				setThreadRunning(false);
				break;
			}
		}

		while (1 == 1) {
			for (IStore store : facade.getStores())
				for (IServer server : store.getSubscribedServers())
					for (INewsgroup group : facade
							.getSubscribedNewsgroups(server)) {
						facade.updateAttributes(group);
					}
			try {
				Debug.log(getClass(),
						"Salvo Thread: Update finished sleeping 600 seconds");
				Thread.sleep(600000);
			} catch (InterruptedException e) {
				setThreadRunning(false);
				break;
			}
		}
	}

	private void setThreadRunning(boolean threadRunning) {
		this.threadRunning = threadRunning;
	}

	public boolean isThreadRunning() {
		return threadRunning;
	}
}