package com.weltevree.salvo.model;

import java.util.Collection;

/**
 * This class controls fetching of information from the server or from the
 * store.
 * 
 * @author jongw
 * 
 */
public interface IServerStoreFacade extends IInputOutputSystem {

	/**
	 * If an exception occurred in the store or the sever connection it is
	 * stored and you can retrieve it with this method.
	 * 
	 * @return
	 */
	public Exception getLastException();

	/**
	 * Catches up since the last visit to the server and stores the information
	 * in the store.
	 * 
	 * @param newsgroup
	 */
	public void catchUp(INewsgroup newsgroup);

	public Collection<INewsgroup> getSubscribedNewsgroups(IServer server);

	public Collection<IStore> getStores();

	public void init();

	public boolean replyToArticle(IArticle article, StringBuffer buffer);

	public boolean postNewArticle(INewsgroup[] newsgroups, String subject,
			StringBuffer buffer);

	public Collection<IArticle> getAllFollowUps(IArticle article);

	/**
	 * Gets the first store in the list of stores.
	 * 
	 * @return
	 */
	public IStore getFirstStore();

}
