package com.weltevree.salvo.model;

public interface IStoreEventProvider {

	/**
	 * Removes the listener from the list of listeners.
	 * 
	 * @param listener
	 */
	public void removeListener(IStoreEventListener listener);

	/**
	 * Adds the listener to the list of listeners that get notified if an event
	 * of the specified type occurs.
	 * 
	 * @param listener
	 * @param eventType
	 */
	public void addListener(IStoreEventListener listener, int eventType);

	public void fireEvent(IStoreEvent event);


}
