package com.weltevree.salvo.model;


public class SALVO {

	public static final String NAMESPACE = "com.weltvree.salvo";

	/**
	 * IStoreEvent event constants
	 */
	public static final int EVENT_ADD_SERVER = 1;

	public static final int EVENT_ADD_GROUP = 2;

	public static final int EVENT_ADD = EVENT_ADD_GROUP | EVENT_ADD_SERVER;

	public static final int EVENT_REMOVE_SERVER = 4;

	public static final int EVENT_REMOVE_GROUP = 8;

	public static final int EVENT_REMOVE = EVENT_REMOVE_GROUP | EVENT_REMOVE_SERVER;

	public static final int EVENT_CHANGE_SERVER = 16;

	public static final int EVENT_CHANGE_GROUP = 32;

	public static final int EVENT_RELOAD = 64;

	public static final int EVENT_CHANGE = EVENT_CHANGE_GROUP | EVENT_CHANGE_SERVER;

	public static final int EVENT_ALL_EVENTS = EVENT_CHANGE | EVENT_REMOVE | EVENT_ADD | EVENT_RELOAD;

	/**
	 * The home of Salvo. Could be used by IStore objects to save stuff.
	 */
	public static String SALVO_HOME = System.getProperty("user.home") + "\\.salvo";

	/**
	 * Defines the default batch of articles to fetch.
	 */
	public static int DEFAULT_BATCH = 50;

	/**
	 * Fetches the oldest
	 */
	public static final int FETCH_OLDEST = 1;

	/**
	 * Fetches the newest
	 */
	public static final int FETCH_NEWEST = 2;

	/**
	 * Fetch the next newer
	 */
	public static final int FETCH_NEXT_NEWER = 4;

	/**
	 * Fetches the next older
	 */
	public static final int FETCH_NEXT_OLDER = 8;

	/**
	 * Fetches the indicated
	 */
	public static final int FETCH_THIS = 16;

	/**
	 * Platform independent CRLF
	 */
	public static final String CRLF = System.getProperty("line.separator");

	/**
	 * Number of articles to fetch from the server
	 */
	public static final int BATCH_SIZE = 200;

	/**
	 * Place holder locations
	 */
	public static final String APPLICATION_LEFT = "com.weltevree.salvo.application.left";

	public static final String APPLICATION_BOTTOMLEFT = "com.weltevree.salvo.application.bottomleft";

	public static final String APPLICATION_BOTTOMRIGHT = "com.weltevree.salvo.application.bottomright";

	public static final String APPLICATION_RIGHT = "com.weltevree.salvo.application.right";

	public static final int LINE_LENGTH = 78;

}
