package com.weltevree.salvo.model;

public class StoreEvent implements IStoreEvent {

	private final Object object;
	private final int eventType;

	public StoreEvent(Object object, int eventType) {
		this.object = object;
		this.eventType = eventType;
	}

	public Object getEventObject() {
		return object;
	}

	public int getEventType() {
		return eventType;
	}

	@Override
	public String toString() {
		return object.toString().concat(eventType + "");
	}

	@Override
	public boolean equals(Object obj) {
		return this.toString().equals(obj.toString());
	}

	@Override
	public int hashCode() {
		return toString().hashCode();
	}
}
