package com.weltevree.salvo.ui.navigator.internal.views;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.jface.viewers.TreePath;
import org.eclipse.swt.widgets.Display;
import org.eclipse.ui.navigator.CommonNavigator;

import com.weltevree.salvo.core.Debug;
import com.weltevree.salvo.core.ServerStoreFactory;
import com.weltevree.salvo.model.INewsgroup;
import com.weltevree.salvo.model.IServer;
import com.weltevree.salvo.model.IStore;
import com.weltevree.salvo.model.IStoreEvent;
import com.weltevree.salvo.model.IStoreEventListener;
import com.weltevree.salvo.model.SALVO;
import com.weltevree.salvo.ui.internal.provider.SubscribedServerProvider;
import com.weltevree.salvo.ui.internal.resources.ISalvoResource;
import com.weltevree.salvo.ui.internal.resources.SalvoResourceFactory;

public class GroupView extends CommonNavigator implements IStoreEventListener {
	public static final String ID = "com.weltevree.salvo.application.view";

	@Override
	protected IAdaptable getInitialInput() {
		ISalvoResource root = SalvoResourceFactory.getResource("root", "root");
		root.setChildProvider(new SubscribedServerProvider());
		for (IStore store : ServerStoreFactory.instance()
				.getServerStoreFacade().getStores())
			store.addListener(this, SALVO.EVENT_ALL_EVENTS);
		return root;
	}

	public void storeEvent(final IStoreEvent event) {
		Display.getDefault().asyncExec(new Runnable() {
			public void run() {
				if (event.getEventObject() instanceof INewsgroup
						|| event.getEventObject() instanceof IServer) {
					Debug
							.log(this.getClass(), "Event: "
									+ event.getEventType());
					TreePath[] elements = getCommonViewer()
							.getExpandedTreePaths();
					getCommonViewer().getTree().setRedraw(false);
					getCommonViewer().refresh();
					getCommonViewer().setExpandedTreePaths(elements);
					getCommonViewer().getTree().setRedraw(true);
				}
			}
		});
	}
}