package com.weltevree.salvo.ui.internal;

import org.eclipse.core.expressions.PropertyTester;

import com.weltevree.salvo.model.IArticle;
import com.weltevree.salvo.model.INewsgroup;
import com.weltevree.salvo.model.IServer;
import com.weltevree.salvo.ui.internal.resources.ISalvoResource;

public class ResourcePropertyTester extends PropertyTester {

	public boolean test(Object receiver, String property, Object[] args, Object expectedValue) {

		System.out.println(property);

		if (property.equals("class") && receiver.getClass().getName().endsWith(expectedValue.toString()))
			return true;

		if (receiver instanceof ISalvoResource) {

			ISalvoResource resource = (ISalvoResource) receiver;

			if (property.equals("isNewsgroup") && resource.getObject() instanceof INewsgroup)
				return true;

			if (property.equals("isServer") && resource.getObject() instanceof IServer)
				return true;

			if (property.equals("isArticle") && resource.getObject() instanceof IArticle)
				return true;

			if (property.equals("isSubscribable")
					&& (resource.getObject() instanceof INewsgroup || resource.getObject() instanceof IServer))
				return true;

			if (property.equals("hasNewsgroup")
					&& (resource.getObject() instanceof INewsgroup || resource.getObject() instanceof IArticle))
				return true;
			
		}

		return false;
	}

}
