package com.weltevree.salvo.ui.internal;

import org.eclipse.core.runtime.IAdapterFactory;
import org.eclipse.ui.views.properties.IPropertySource;

import com.weltevree.salvo.core.Debug;
import com.weltevree.salvo.model.IArticle;
import com.weltevree.salvo.ui.internal.adapters.ArticlePropertySourceAdapter;
import com.weltevree.salvo.ui.internal.adapters.GenericPropertySourceAdapter;
import com.weltevree.salvo.ui.internal.resources.ISalvoResource;

public class SalvoAdapterFactory implements IAdapterFactory {

	private Class<?>[] adapterList = new Class[] { IPropertySource.class };

	@SuppressWarnings("unchecked")
	public Object getAdapter(Object adaptableObject, Class adapterType) {

		if (adapterType == IPropertySource.class) {
			if (adaptableObject instanceof ISalvoResource) {
				Object object = ((ISalvoResource) adaptableObject).getObject();
				if (object instanceof IArticle) {
					return new ArticlePropertySourceAdapter(object);
				}
				return new GenericPropertySourceAdapter(object);

			} else
				return new GenericPropertySourceAdapter(adaptableObject);
		}

		return null;
	}

	@SuppressWarnings("unchecked")
	public Class[] getAdapterList() {
		Debug.log(getClass(), "getAdapterList" + "(" + ")");
		return adapterList;
	}

}
