package com.weltevree.salvo.ui.internal.adapters;

import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.Arrays;

import org.eclipse.ui.views.properties.IPropertyDescriptor;
import org.eclipse.ui.views.properties.PropertyDescriptor;

import com.weltevree.salvo.model.IArticle;

public class ArticlePropertySourceAdapter extends GenericPropertySourceAdapter {

	public ArticlePropertySourceAdapter(Object object) {
		super(object);
	}

	@Override
	public IPropertyDescriptor[] getPropertyDescriptors() {

		ArrayList<IPropertyDescriptor> result = new ArrayList<IPropertyDescriptor>(Arrays.asList(super
				.getPropertyDescriptors()));
		IArticle article = (IArticle) getObject();
		String[] headers = article.getHeaderAttributes();
		for (String header : headers) {
			result.add(new PropertyDescriptor(header, header));

		}
		return result.toArray(new IPropertyDescriptor[0]);
	}

	@Override
	public Object getPropertyValue(Object id) {
		if (id instanceof Method) {
			return super.getPropertyValue(id);
		}
		return ((IArticle) getObject()).getHeaderAttributeValue(id.toString());
	}
}
