package com.weltevree.salvo.ui.internal.editor;

import org.eclipse.swt.SWT;
import org.eclipse.swt.browser.Browser;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Text;

import com.weltevree.salvo.core.Debug;
import com.weltevree.salvo.model.IArticle;
import com.weltevree.salvo.ui.internal.MimeArticleContentHandler;

public class ArticleWidgetBuilder {

	public static void build(Composite composite, IArticle article, MimeArticleContentHandler handler) {

		String contentType = article.getHeaderAttributeValue("Content-Type");
		Debug.log(ArticleWidgetBuilder.class, "building widget for " + contentType);

		if (contentType == null) {
			contentType = "unknown to SALVO";
		}

		if (contentType.startsWith("text/html")) {
			Browser browser = new Browser(composite, SWT.V_SCROLL);
			browser.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
			browser.setText(handler.getBody());
		}

		else {
			Text text = new Text(composite, SWT.V_SCROLL | SWT.READ_ONLY);
			text.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
			text.setText(handler.getBody());
		}
	}

}
