package com.weltevree.salvo.ui.internal.handlers;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;

import com.weltevree.salvo.core.ServerStoreFactory;
import com.weltevree.salvo.model.IArticle;
import com.weltevree.salvo.model.IServerStoreFacade;
import com.weltevree.salvo.ui.internal.resources.ISalvoResource;
import com.weltevree.salvo.ui.tools.SelectionUtil;

public class MarkArticle extends AbstractHandler {

	public Object execute(ExecutionEvent event) throws ExecutionException {

		ISalvoResource res = (ISalvoResource) SelectionUtil
				.getFirstObjectFromCurrentSelection(ISalvoResource.class);
		if (res != null)
			if (res.getObject() instanceof IArticle) {
				IArticle article = (IArticle) res.getObject();
				article.setMarked(!article.isMarked());
				IServerStoreFacade serverStoreFacade = ServerStoreFactory
						.instance().getServerStoreFacade();
				serverStoreFacade.updateArticle(article);
			}
		return null;
	}
}
