package com.weltevree.salvo.ui.internal.handlers;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.handlers.HandlerUtil;

import com.weltevree.salvo.core.Debug;
import com.weltevree.salvo.model.INewsgroup;
import com.weltevree.salvo.ui.internal.editor.ArticlePanel;
import com.weltevree.salvo.ui.internal.editor.ArticlePanelInput;
import com.weltevree.salvo.ui.internal.resources.ISalvoResource;

public class OpenArticlePanel extends AbstractHandler {

	public Object execute(ExecutionEvent event) throws ExecutionException {

		if (HandlerUtil.getCurrentSelection(event) instanceof IStructuredSelection) {

			IStructuredSelection selection = (IStructuredSelection) HandlerUtil.getCurrentSelection(event);

			for (Object obj : selection.toList()) {
				INewsgroup group = (INewsgroup) ((ISalvoResource) obj).getObject();

				try {
					HandlerUtil.getActiveWorkbenchWindow(event).getActivePage().openEditor(
							new ArticlePanelInput(group), ArticlePanel.ID);
				} catch (PartInitException e) {
					Debug.log(this.getClass(), e.getMessage());
				}
			}
		}

		return null;
	}

}
