package com.weltevree.salvo.ui.internal.handlers;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.handlers.HandlerUtil;

import com.weltevree.salvo.core.Debug;
import com.weltevree.salvo.model.IArticle;
import com.weltevree.salvo.ui.internal.resources.ISalvoResource;
import com.weltevree.salvo.ui.tools.SelectionUtil;

public class ReplyToGroupHandler extends AbstractHandler {

	public Object execute(ExecutionEvent event) throws ExecutionException {

		ISalvoResource res = (ISalvoResource) SelectionUtil
				.getFirstObjectFromCurrentSelection(ISalvoResource.class);
		if (res != null)
			if (res.getObject() instanceof IArticle) {
				IArticle article = (IArticle) res.getObject();
				try {
					HandlerUtil.getActiveWorkbenchWindow(event).getActivePage().showView(
							"com.weltevree.salvo.ui.internal.views.replyView", "" + article.toString(),
							IWorkbenchPage.VIEW_ACTIVATE);
				} catch (PartInitException e) {
					Debug.log(getClass(), e);
				}
			}
		return null;
	}
}
