package com.weltevree.salvo.ui.internal.handlers;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.ui.handlers.HandlerUtil;

import com.weltevree.salvo.model.IServer;
import com.weltevree.salvo.ui.internal.resources.ISalvoResource;
import com.weltevree.salvo.ui.internal.wizards.SubscribeGroupWizard;

public class SubscribeHandler extends AbstractHandler {

	public Object execute(ExecutionEvent event) throws ExecutionException {

		IStructuredSelection selection = (IStructuredSelection) HandlerUtil.getCurrentSelection(event);

		if (selection.getFirstElement() instanceof ISalvoResource) {
			ISalvoResource resource = (ISalvoResource) selection.getFirstElement();

			if (resource.getObject() instanceof IServer) {
				SubscribeGroupWizard wizard = new SubscribeGroupWizard((IServer) resource.getObject());
				WizardDialog dialog = new WizardDialog(HandlerUtil.getActiveShell(event), wizard);
				dialog.create();
				dialog.open();
			}
		}
		return null;
	}
}
