package com.weltevree.salvo.ui.internal.handlers;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.dialogs.MessageDialogWithToggle;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.window.Window;
import org.eclipse.ui.handlers.HandlerUtil;

import com.weltevree.salvo.core.ServerStoreFactory;
import com.weltevree.salvo.model.INewsgroup;
import com.weltevree.salvo.model.IServer;
import com.weltevree.salvo.ui.internal.resources.ISalvoResource;

public class UnsubscribeHandler extends AbstractHandler {

	public Object execute(ExecutionEvent event) throws ExecutionException {

		ISelection selection = HandlerUtil.getCurrentSelection(event);
		if (selection instanceof IStructuredSelection) {
			for (Object selo : ((IStructuredSelection) selection).toArray()) {
				if (selo instanceof ISalvoResource) {
					Object object = ((ISalvoResource) selo).getObject();
					if (object instanceof IServer) {

						MessageDialogWithToggle x = MessageDialogWithToggle.openInformation(HandlerUtil
								.getActiveShell(event), ((IServer) object).getAddress(),
								"Do you want to unsubscribe from server " + ((IServer) object).getAddress()
										+ "?", "Delete resource contents on disk? (cannot be undone)", false,
								null, null);
						if (x.getReturnCode() == Window.OK) {
							ServerStoreFactory.instance().getServerStoreFacade().unsubscribeServer(
									(IServer) object, x.getToggleState());
						}

					} else if (object instanceof INewsgroup) {
						boolean x = MessageDialog.openConfirm(HandlerUtil.getActiveShell(event),
								((INewsgroup) object).getNewsgroupName(),
								"Do you want to unsubscribe from group "
										+ ((INewsgroup) object).getNewsgroupName() + "?");
						if (x) {
							ServerStoreFactory.instance().getServerStoreFacade().unsubscribeNewsgroup(
									(INewsgroup) object, false);
						}
					}
				}
			}
		}

		return null;
	}
}
