package com.weltevree.salvo.ui.internal.provider;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

import com.weltevree.salvo.model.INewsgroup;
import com.weltevree.salvo.model.IServer;
import com.weltevree.salvo.ui.internal.resources.ISalvoResource;
import com.weltevree.salvo.ui.internal.resources.SalvoResourceFactory;

public class NewsGroupProvider implements IChildProvider {

	private ISalvoResource parent;

	public NewsGroupProvider(ISalvoResource parent) {
		this.parent = parent;
	}

	public Collection<ISalvoResource> getChildren() {

		ArrayList<ISalvoResource> result = new ArrayList<ISalvoResource>();

		if (parent.getObject() instanceof IServer) {

			IServer server = (IServer) parent.getObject();
			Collection<INewsgroup> list = server.getServerConnection().getNewsgroups();
			Leveler firstLeveler = new Leveler(server.getAddress());
			for (Iterator<INewsgroup> iterator = list.iterator(); iterator.hasNext();) {

				INewsgroup newsgroup = iterator.next();
				firstLeveler.storeGroup(server, newsgroup);
			}

			Collection<Object> intRes = firstLeveler.getChildren(server);
			for (Iterator<Object> iterator = intRes.iterator(); iterator.hasNext();) {
				Object object = (Object) iterator.next();

				if (object instanceof Leveler) {
					Leveler leveler = (Leveler) object;
					String name = leveler.getLevelText() + ".*";
					ISalvoResource salvoResource = SalvoResourceFactory.getResource(name, leveler);
					salvoResource.setChildProvider(new LevelerChildProvider(leveler));
					result.add(salvoResource);
				}

				if (object instanceof INewsgroup) {
					INewsgroup group = (INewsgroup) object;
					String name = group.getNewsgroupName();
					ISalvoResource salvoResource = SalvoResourceFactory.getResource(name, group);
					result.add(salvoResource);
				}
			}
		}

		return result;
	}

	public ISalvoResource getParent() {
		return parent;
	}

}
