package com.weltevree.salvo.ui.internal.provider;

import org.eclipse.core.runtime.Platform;
import org.eclipse.jface.viewers.IDecoration;
import org.eclipse.jface.viewers.ILabelProviderListener;
import org.eclipse.jface.viewers.ILightweightLabelDecorator;
import org.eclipse.swt.widgets.Display;
import org.eclipse.ui.PlatformUI;

import com.weltevree.salvo.core.Debug;
import com.weltevree.salvo.model.IArticle;
import com.weltevree.salvo.model.INewsgroup;
import com.weltevree.salvo.model.IStoreEvent;
import com.weltevree.salvo.model.IStoreEventListener;
import com.weltevree.salvo.ui.internal.resources.ISalvoResource;

public class SalvoDecorator implements ILightweightLabelDecorator, IStoreEventListener {

	public void decorate(Object element, IDecoration decoration) {

		Debug.log(this.getClass(), "Decorating object " + element);

		// Get the resource
		// 
		ISalvoResource resource = null;
		if (element instanceof ISalvoResource)
			resource = (ISalvoResource) element;
		else

			resource = (ISalvoResource) Platform.getAdapterManager()
					.getAdapter(element, ISalvoResource.class);

		if (resource == null)
			return;

		//
		// Get the decorations
		if (resource.getObject() instanceof INewsgroup)
			decorate((INewsgroup) resource.getObject(), decoration);

		if (resource.getObject() instanceof IArticle)
			Debug.log(getClass(), "ja hoor een article");

	//	ServerStoreFactory.instance().getServerStoreFacade().getStore().addListener(this,
	//			SALVO.EVENT_ALL_EVENTS);

	}

	private void decorate(INewsgroup newsgroup, IDecoration decoration) {
		Debug.log(this.getClass(), "Decorating newsgroup: " + newsgroup.getNewsgroupName());
		decoration.addSuffix(" (" + newsgroup.getArticleCount() + ")");
	}

	public void addListener(ILabelProviderListener listener) {
		// TODO Auto-generated method stub

	}

	public void dispose() {
		// TODO Auto-generated method stub

	}

	public boolean isLabelProperty(Object element, String property) {
		// TODO Auto-generated method stub
		return false;
	}

	public void removeListener(ILabelProviderListener listener) {
		// TODO Auto-generated method stub

	}

	public void storeEvent(IStoreEvent event) {
		Display.getDefault().asyncExec(new Runnable() {
			public void run() {
				Debug.log(this.getClass(), "Caught store event, firing a decorator event");
				PlatformUI.getWorkbench().getDecoratorManager().update("com.weltevree.salvo.ui.decorator1");
			}
		});

	}

}
