package com.weltevree.salvo.ui.internal.provider;

import java.util.ArrayList;
import java.util.Collection;

import com.weltevree.salvo.core.ServerStoreFactory;
import com.weltevree.salvo.model.INewsgroup;
import com.weltevree.salvo.model.IServer;
import com.weltevree.salvo.ui.internal.resources.ISalvoResource;
import com.weltevree.salvo.ui.internal.resources.SalvoResourceFactory;

public class SubscribedNewsGroupProvider implements IChildProvider {

	private ISalvoResource parent;

	public SubscribedNewsGroupProvider(ISalvoResource parent) {
		this.parent = parent;
	}

	public Collection<ISalvoResource> getChildren() {

		ArrayList<ISalvoResource> result = new ArrayList<ISalvoResource>();

		if (parent.getObject() instanceof IServer) {

			IServer server = (IServer) parent.getObject();
			Collection<INewsgroup> groups = ServerStoreFactory.instance().getServerStoreFacade()
					.getSubscribedNewsgroups(server);

			for (INewsgroup group : groups) {
				String name = group.getNewsgroupName();
				ISalvoResource salvoResource = SalvoResourceFactory.getResource(name, group);
				result.add(salvoResource);
			}
		}
		return result;
	}

	public ISalvoResource getParent() {
		return parent;
	}

}
