package com.weltevree.salvo.ui.internal.provider;

import java.util.ArrayList;
import java.util.Collection;

import com.weltevree.salvo.core.ServerStoreFactory;
import com.weltevree.salvo.model.IServer;
import com.weltevree.salvo.ui.internal.resources.ISalvoResource;
import com.weltevree.salvo.ui.internal.resources.SalvoResourceFactory;

public class SubscribedServerProvider implements IChildProvider {

	public Collection<ISalvoResource> getChildren() {

		ArrayList<ISalvoResource> result = new ArrayList<ISalvoResource>();

		for (IServer server : ServerStoreFactory.instance()
				.getServerStoreFacade().getFirstStore().getSubscribedServers()) {
			ISalvoResource s1 = SalvoResourceFactory.getResource(server
					.getAddress(), server);
			s1.setChildProvider(new SubscribedNewsGroupProvider(s1));
			result.add(s1);
		}
		return result;
	}

	public ISalvoResource getParent() {
		return null;
	}

}
