package com.weltevree.salvo.ui.internal.wizards;

import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.IWizardPage;
import org.eclipse.jface.wizard.Wizard;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.INewWizard;
import org.eclipse.ui.IWorkbench;

import com.weltevree.salvo.core.ServerStoreFactory;
import com.weltevree.salvo.model.INewsgroup;
import com.weltevree.salvo.model.IServer;
import com.weltevree.salvo.model.IServerStoreFacade;

public class NewNewsServerWizard extends Wizard implements INewWizard {

	private NewNewsServerWizardPage page1;
	private SubscribeGroupWizardPage page2;
	private IServer server;

	public NewNewsServerWizard() {
	}
	
	public NewNewsServerWizard(IServer server) {
		this.server = server;
	}

	public void addPages() {
		page1 = new NewNewsServerWizardPage("Get Server Information");
		page2 = new SubscribeGroupWizardPage("Subscribe to Group");
		addPage(page1);
		addPage(page2);
	}

	public boolean performFinish() {

		IServerStoreFacade storeFacade = ServerStoreFactory.instance().getServerStoreFacade();
		storeFacade.subscribeServer(page1.getServer(), page1.getPass());

		for (INewsgroup group : page2.getGroups()) {
			storeFacade.subscribeNewsgroup(group);
		}

		return true;
	}

	public void init(IWorkbench workbench, IStructuredSelection selection) {

	}

	@Override
	public void createPageControls(Composite pageContainer) {
		IWizardPage page = (IWizardPage) super.getPages()[0];
		page.createControl(pageContainer);
	}

	@Override
	public IWizardPage getNextPage(IWizardPage page) {
		if (page instanceof SubscribeGroupWizardPage)
			((SubscribeGroupWizardPage) page).setInput(page1.getServer());
		return super.getNextPage(page);
	}

	public IServer getServer() {
		return server;	}
}
