package com.weltevree.salvo.ui.internal.wizards;

import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.IWizardPage;
import org.eclipse.jface.wizard.Wizard;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.INewWizard;
import org.eclipse.ui.IWorkbench;

import com.weltevree.salvo.core.ServerStoreFactory;
import com.weltevree.salvo.model.INewsgroup;
import com.weltevree.salvo.model.IServer;
import com.weltevree.salvo.model.IServerStoreFacade;

public class SubscribeGroupWizard extends Wizard implements INewWizard {

	private SubscribeGroupWizardPage page1;
	private final IServer server;

	public SubscribeGroupWizard(IServer server) {
		this.server = server;
	}

	@Override
	public void addPages() {
		page1 = new SubscribeGroupWizardPage("Subscribe to Group");
		addPage(page1);
	}

	@Override
	public boolean performFinish() {

		IServerStoreFacade storeFacade = ServerStoreFactory.instance().getServerStoreFacade();
		for (INewsgroup group : page1.getGroups()) {
			storeFacade.subscribeNewsgroup(group);
		}
		return true;
	}

	public void init(IWorkbench workbench, IStructuredSelection selection) {

	}

	@Override
	public void createPageControls(Composite pageContainer) {
		IWizardPage page = (IWizardPage) super.getPages()[0];
		page.createControl(pageContainer);
		page1.setInput(server);
	}

	@Override
	public IWizardPage getNextPage(IWizardPage page) {
		return super.getNextPage(page);
	}
}
